package exemplo.clv.ajustavel;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "exemplo.clv.ajustavel", "exemplo.clv.ajustavel.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "exemplo.clv.ajustavel", "exemplo.clv.ajustavel.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "exemplo.clv.ajustavel.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.B4XViewWrapper.XUI _xui = null;
public exemplo.clv.ajustavel.customlistview _clvmensagens = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbnome = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbmensagem = null;
public static int _messagesize = 0;
public static int _margin = 0;
public static int _internalymargin = 0;
public anywheresoftware.b4a.objects.PanelWrapper _pwhite = null;
public static int _leftcolor = 0;
public static int _rightcolor = 0;
public static boolean _border = false;
public static int _bordercolor = 0;
public static int _borderwidth = 0;
public exemplo.clv.ajustavel.starter _starter = null;
public static class _messagedata{
public boolean IsInitialized;
public boolean Left;
public String Name;
public String Message;
public void Initialize() {
IsInitialized = true;
Left = false;
Name = "";
Message = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 36;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 38;BA.debugLine="FillList";
_filllist();
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 48;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 44;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _add_conversation(boolean _leftchat,String _name,String _message,anywheresoftware.b4a.objects.B4XViewWrapper _p,int _index) throws Exception{
anywheresoftware.b4a.objects.StringUtils _su = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd = null;
 //BA.debugLineNum = 103;BA.debugLine="Sub Add_Conversation (leftChat As Boolean, name As";
 //BA.debugLineNum = 105;BA.debugLine="p.LoadLayout(\"dentroClv\")";
_p.LoadLayout("dentroClv",mostCurrent.activityBA);
 //BA.debugLineNum = 108;BA.debugLine="lbNome.Text = name";
mostCurrent._lbnome.setText(BA.ObjectToCharSequence(_name));
 //BA.debugLineNum = 109;BA.debugLine="lbMensagem.Text = message";
mostCurrent._lbmensagem.setText(BA.ObjectToCharSequence(_message));
 //BA.debugLineNum = 113;BA.debugLine="If leftChat Then";
if (_leftchat) { 
 //BA.debugLineNum = 114;BA.debugLine="pWhite.Left = margin";
mostCurrent._pwhite.setLeft(_margin);
 //BA.debugLineNum = 115;BA.debugLine="lbNome.Gravity = Bit.Or(Gravity.LEFT,Gravity.CEN";
mostCurrent._lbnome.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.LEFT,anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 //BA.debugLineNum = 116;BA.debugLine="lbMensagem.Gravity = Bit.Or(Gravity.LEFT,Gravity";
mostCurrent._lbmensagem.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.LEFT,anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 }else {
 //BA.debugLineNum = 118;BA.debugLine="pWhite.Left = 100%x - messageSize - margin";
mostCurrent._pwhite.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-_messagesize-_margin));
 //BA.debugLineNum = 119;BA.debugLine="lbNome.Gravity = Bit.Or(Gravity.RIGHT,Gravity.TO";
mostCurrent._lbnome.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.RIGHT,anywheresoftware.b4a.keywords.Common.Gravity.TOP));
 //BA.debugLineNum = 120;BA.debugLine="lbMensagem.Gravity = Bit.Or(Gravity.RIGHT,Gravit";
mostCurrent._lbmensagem.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.RIGHT,anywheresoftware.b4a.keywords.Common.Gravity.TOP));
 };
 //BA.debugLineNum = 126;BA.debugLine="Private su As StringUtils";
_su = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 127;BA.debugLine="lbNome.Top = 0 + internalYMargin";
mostCurrent._lbnome.setTop((int) (0+_internalymargin));
 //BA.debugLineNum = 128;BA.debugLine="lbNome.Height =su.MeasureMultilineTextHeight(lbNo";
mostCurrent._lbnome.setHeight(_su.MeasureMultilineTextHeight((android.widget.TextView)(mostCurrent._lbnome.getObject()),BA.ObjectToCharSequence(mostCurrent._lbnome.getText())));
 //BA.debugLineNum = 129;BA.debugLine="lbMensagem.Height =su.MeasureMultilineTextHeight(";
mostCurrent._lbmensagem.setHeight(_su.MeasureMultilineTextHeight((android.widget.TextView)(mostCurrent._lbmensagem.getObject()),BA.ObjectToCharSequence(mostCurrent._lbmensagem.getText())));
 //BA.debugLineNum = 130;BA.debugLine="lbMensagem.Top = lbNome.Top + lbNome.Height";
mostCurrent._lbmensagem.setTop((int) (mostCurrent._lbnome.getTop()+mostCurrent._lbnome.getHeight()));
 //BA.debugLineNum = 134;BA.debugLine="p.Height = lbNome.Height + lbMensagem.Height + (i";
_p.setHeight((int) (mostCurrent._lbnome.getHeight()+mostCurrent._lbmensagem.getHeight()+(_internalymargin*2)));
 //BA.debugLineNum = 135;BA.debugLine="pWhite.Height = lbNome.Height + lbMensagem.Height";
mostCurrent._pwhite.setHeight((int) (mostCurrent._lbnome.getHeight()+mostCurrent._lbmensagem.getHeight()+(_internalymargin*2)));
 //BA.debugLineNum = 143;BA.debugLine="If border Then";
if (_border) { 
 //BA.debugLineNum = 144;BA.debugLine="If leftChat Then";
if (_leftchat) { 
 //BA.debugLineNum = 145;BA.debugLine="Private cd As ColorDrawable";
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 146;BA.debugLine="cd.Initialize2(leftColor,5,borderWidth,borderCo";
_cd.Initialize2(_leftcolor,(int) (5),_borderwidth,_bordercolor);
 //BA.debugLineNum = 147;BA.debugLine="pWhite.Background = cd";
mostCurrent._pwhite.setBackground((android.graphics.drawable.Drawable)(_cd.getObject()));
 }else {
 //BA.debugLineNum = 149;BA.debugLine="Private cd As ColorDrawable";
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 150;BA.debugLine="cd.Initialize2(rightColor,5,borderWidth,borderC";
_cd.Initialize2(_rightcolor,(int) (5),_borderwidth,_bordercolor);
 //BA.debugLineNum = 151;BA.debugLine="pWhite.Background = cd";
mostCurrent._pwhite.setBackground((android.graphics.drawable.Drawable)(_cd.getObject()));
 };
 }else {
 //BA.debugLineNum = 154;BA.debugLine="If leftChat Then";
if (_leftchat) { 
 //BA.debugLineNum = 155;BA.debugLine="Private cd As ColorDrawable";
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 156;BA.debugLine="cd.Initialize2(leftColor,5,0,borderColor)";
_cd.Initialize2(_leftcolor,(int) (5),(int) (0),_bordercolor);
 //BA.debugLineNum = 157;BA.debugLine="pWhite.Background = cd";
mostCurrent._pwhite.setBackground((android.graphics.drawable.Drawable)(_cd.getObject()));
 }else {
 //BA.debugLineNum = 159;BA.debugLine="Private cd As ColorDrawable";
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 160;BA.debugLine="cd.Initialize2(rightColor,5,0,borderColor)";
_cd.Initialize2(_rightcolor,(int) (5),(int) (0),_bordercolor);
 //BA.debugLineNum = 161;BA.debugLine="pWhite.Background = cd";
mostCurrent._pwhite.setBackground((android.graphics.drawable.Drawable)(_cd.getObject()));
 };
 };
 //BA.debugLineNum = 167;BA.debugLine="clvMensagens.ResizeItem(index,p.Height)";
mostCurrent._clvmensagens._resizeitem(_index,_p.getHeight());
 //BA.debugLineNum = 169;BA.debugLine="End Sub";
return "";
}
public static String  _clvmensagens_visiblerangechanged(int _firstindex,int _lastindex) throws Exception{
int _extrasize = 0;
int _i = 0;
anywheresoftware.b4a.objects.B4XViewWrapper _p = null;
exemplo.clv.ajustavel.main._messagedata _md = null;
 //BA.debugLineNum = 78;BA.debugLine="Sub clvMensagens_VisibleRangeChanged (FirstIndex A";
 //BA.debugLineNum = 79;BA.debugLine="Dim ExtraSize As Int = 20";
_extrasize = (int) (20);
 //BA.debugLineNum = 81;BA.debugLine="For i = 0 To clvMensagens.Size - 1";
{
final int step2 = 1;
final int limit2 = (int) (mostCurrent._clvmensagens._getsize()-1);
_i = (int) (0) ;
for (;_i <= limit2 ;_i = _i + step2 ) {
 //BA.debugLineNum = 82;BA.debugLine="Dim p As B4XView = clvMensagens.GetPanel(i)";
_p = new anywheresoftware.b4a.objects.B4XViewWrapper();
_p = mostCurrent._clvmensagens._getpanel(_i);
 //BA.debugLineNum = 83;BA.debugLine="If i > FirstIndex - ExtraSize And i < LastIndex";
if (_i>_firstindex-_extrasize && _i<_lastindex+_extrasize) { 
 //BA.debugLineNum = 85;BA.debugLine="If p.NumberOfViews = 0 Then";
if (_p.getNumberOfViews()==0) { 
 //BA.debugLineNum = 86;BA.debugLine="Dim md As MessageData = clvMensagens.GetValue(";
_md = (exemplo.clv.ajustavel.main._messagedata)(mostCurrent._clvmensagens._getvalue(_i));
 //BA.debugLineNum = 87;BA.debugLine="Add_Conversation(md.Left, md.Name, md.Message,";
_add_conversation(_md.Left,_md.Name,_md.Message,_p,_i);
 };
 //BA.debugLineNum = 89;BA.debugLine="p.SetVisibleAnimated(2000,True)";
_p.SetVisibleAnimated((int) (2000),anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 92;BA.debugLine="If p.NumberOfViews > 0 Then";
if (_p.getNumberOfViews()>0) { 
 //BA.debugLineNum = 93;BA.debugLine="p.RemoveAllViews '<--- remove the layout";
_p.RemoveAllViews();
 //BA.debugLineNum = 94;BA.debugLine="p.Visible = False";
_p.setVisible(anywheresoftware.b4a.keywords.Common.False);
 };
 };
 }
};
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _filllist() throws Exception{
anywheresoftware.b4a.objects.collections.List _nomes = null;
anywheresoftware.b4a.objects.collections.List _mensagens = null;
long _n = 0L;
int _i = 0;
exemplo.clv.ajustavel.main._messagedata _md = null;
anywheresoftware.b4a.objects.B4XViewWrapper _p = null;
 //BA.debugLineNum = 52;BA.debugLine="Sub FillList";
 //BA.debugLineNum = 53;BA.debugLine="Dim nomes As List = Array(File.ReadString(File.Di";
_nomes = new anywheresoftware.b4a.objects.collections.List();
_nomes = anywheresoftware.b4a.keywords.Common.ArrayToList(new Object[]{(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"nome1.txt")),(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"nome2.txt")),(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"nome3.txt"))});
 //BA.debugLineNum = 55;BA.debugLine="Dim mensagens As List = Array(File.ReadString(Fil";
_mensagens = new anywheresoftware.b4a.objects.collections.List();
_mensagens = anywheresoftware.b4a.keywords.Common.ArrayToList(new Object[]{(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"mensagem1.txt")),(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"mensagem2.txt")),(Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"mensagem3.txt"))});
 //BA.debugLineNum = 58;BA.debugLine="Dim n As Long = DateTime.Now";
_n = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 60;BA.debugLine="For i = 1 To 1000";
{
final int step4 = 1;
final int limit4 = (int) (1000);
_i = (int) (1) ;
for (;_i <= limit4 ;_i = _i + step4 ) {
 //BA.debugLineNum = 61;BA.debugLine="Dim md As MessageData";
_md = new exemplo.clv.ajustavel.main._messagedata();
 //BA.debugLineNum = 62;BA.debugLine="md.Initialize";
_md.Initialize();
 //BA.debugLineNum = 63;BA.debugLine="md.Name = nomes.Get((i - 1) Mod nomes.Size)";
_md.Name = BA.ObjectToString(_nomes.Get((int) ((_i-1)%_nomes.getSize())));
 //BA.debugLineNum = 64;BA.debugLine="md.Message = mensagens.Get((i - 1) Mod mensagens";
_md.Message = BA.ObjectToString(_mensagens.Get((int) ((_i-1)%_mensagens.getSize())));
 //BA.debugLineNum = 65;BA.debugLine="If i Mod 2 = 0 Then";
if (_i%2==0) { 
 //BA.debugLineNum = 66;BA.debugLine="md.Left = True";
_md.Left = anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 68;BA.debugLine="md.Left = False";
_md.Left = anywheresoftware.b4a.keywords.Common.False;
 };
 //BA.debugLineNum = 70;BA.debugLine="Dim p As B4XView = xui.CreatePanel(\"\")";
_p = new anywheresoftware.b4a.objects.B4XViewWrapper();
_p = _xui.CreatePanel(processBA,"");
 //BA.debugLineNum = 71;BA.debugLine="p.SetLayoutAnimated(0, margin, 0, messageSize, 5";
_p.SetLayoutAnimated((int) (0),_margin,(int) (0),_messagesize,anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5),mostCurrent.activityBA));
 //BA.debugLineNum = 72;BA.debugLine="clvMensagens.Add(p, md)";
mostCurrent._clvmensagens._add(_p,(Object)(_md));
 }
};
 //BA.debugLineNum = 75;BA.debugLine="Log(\"Loading took: \" & (DateTime.Now - n) & \"ms\")";
anywheresoftware.b4a.keywords.Common.Log("Loading took: "+BA.NumberToString((anywheresoftware.b4a.keywords.Common.DateTime.getNow()-_n))+"ms");
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 18;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 19;BA.debugLine="Private clvMensagens As CustomListView";
mostCurrent._clvmensagens = new exemplo.clv.ajustavel.customlistview();
 //BA.debugLineNum = 20;BA.debugLine="Private lbNome As Label";
mostCurrent._lbnome = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Private lbMensagem As Label";
mostCurrent._lbmensagem = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Private messageSize As Int = 85%x";
_messagesize = anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (85),mostCurrent.activityBA);
 //BA.debugLineNum = 23;BA.debugLine="Private margin As Int = 2%x";
_margin = anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (2),mostCurrent.activityBA);
 //BA.debugLineNum = 24;BA.debugLine="Private internalYMargin As Int = 2%y";
_internalymargin = anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (2),mostCurrent.activityBA);
 //BA.debugLineNum = 25;BA.debugLine="Private pWhite As Panel";
mostCurrent._pwhite = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Private leftColor As Int = Colors.White";
_leftcolor = anywheresoftware.b4a.keywords.Common.Colors.White;
 //BA.debugLineNum = 27;BA.debugLine="Private rightColor As Int = Colors.RGB(255,243,20";
_rightcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (255),(int) (243),(int) (209));
 //BA.debugLineNum = 28;BA.debugLine="Private border As Boolean = True";
_border = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 29;BA.debugLine="Private borderColor As Int = Colors.Black";
_bordercolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 30;BA.debugLine="Private borderWidth As Int = 1dip";
_borderwidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1));
 //BA.debugLineNum = 32;BA.debugLine="Type MessageData (Left As Boolean, Name As String";
;
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 14;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="Private xui As XUI";
_xui = new anywheresoftware.b4a.objects.B4XViewWrapper.XUI();
 //BA.debugLineNum = 16;BA.debugLine="End Sub";
return "";
}
}
